-- Get the keyboard function for text input. This will also print out the keyboard to the bottom screen and require() functions.inc.lua
require( "keyboard.inc.lua" )

-- Screen variables for easier code reading
SCREEN_TOP = 1
SCREEN_BOTTOM = 0

-- Set up top screen to display text
BGTopText = Screen.LoadTextBG()
Screen.Initialize( SCREEN_TOP, BGTopText )
BGTopText:SetColor( 7 )

-- Load the questions
wordWrap( "Press X to load default question file. (QUESTIONS.TRIV.) Press Y to type in another questions file to load.", 0, 0, 7, SCREEN_TOP )
x = 0
while x == 0 do
	if Pads.X() then
		file = "QUESTIONS"
		x = 1
	end
	if Pads.Y() then
		BGTopText:Clear()
		wordWrap( "Your file must end in .TRIV. Do not type the .TRIV, the program does that for you. It should be all in uppercase.", 0, 0, 7, SCREEN_TOP )
		file = keyboard()
		x = 1
	end
end
file = file .. ".TRIV"
io.input( file )
BGTopText:Clear()

-- Load all questions into an array
questions = {}
questionnumber = 0
num_of_questions = 0
current_question = 0

while current_question ~= nil do
	BGTopText:PrintXY( 1, 1, num_of_questions )
	questionnumber = questionnumber + 1
	current_question = io.read( "*line" )
	questions[questionnumber] = current_question
	num_of_questions = questionnumber
end
num_of_questions = num_of_questions - 1

-- Function to grab a random question
function getQuestion()
	math.randomseed( DSLua.VBlankCount() )
	randomquestion = math.random( 1, num_of_questions )
	return randomquestion
end

-- Function to seperate question into parts
function seperateQuestion( questionnumber )
	question_op = questions[questionnumber]
	
	-- First get the question text
	position_of_two_slashes, unusedvariable = string.find( question_op, "//" )
	question_text = string.sub( question_op, position_of_two_slashes + 2, string.len( question_op ) )
	
	-- The category
	position_of_first_slash, unusedvariable = string.find( question_op, "/", 2 )
	category_text = string.sub( question_op, 2, position_of_first_slash - 1 )
	category_text = string.gsub( category_text, "&", " and " )
	
	-- Answer
	answer = string.sub( question_op, position_of_first_slash + 1, position_of_two_slashes - 1 )
	
	-- Hint
	hint = string.gsub( answer, "%w", "_" )
end

points = 0

BGTopText:PrintXY( 1, 1, "Welcome to DStrivia." )
BGTopText:PrintXY( 1, 3, "How many questions do you want?" )

number_of_questions = keyboard()

BGTopText:Clear()

for current_question_number = 1, number_of_questions do
	seperateQuestion( getQuestion() )

	BGTopText:PrintXY( 0, 1, "Question #" .. current_question_number .. "/" .. number_of_questions )
	BGTopText:PrintXY( 0, 2, "Category: " )
	BGTopText:SetColor( 1 )
	BGTopText:PrintXY( 10, 2, category_text )
	BGTopText:SetColor( 7 )
	BGTopText:PrintXY( 0, 4, "Question: " )
	BGTopText:SetColor( 1 )
	wordWrap( question_text, 10, 4, 1, SCREEN_TOP )
	BGTopText:SetColor( 7 )
	BGTopText:PrintXY( 0, 10, "Hint: " )
	BGTopText:SetColor( 1 )
	wordWrap( hint, 6, 10, 1, SCREEN_TOP )
	BGTopText:SetColor( 7 )
	
	guess = keyboard()
	
	if string.upper( guess ) == string.upper( answer ) then
		points = points + 1
		BGTopText:PrintXY( 1, 12, "------------------------------" )
		wordWrap( "Correct! You have " .. points .. " points. Press any key to continue.", 1, 14, 7, SCREEN_TOP )
	else
		BGTopText:PrintXY( 1, 12, "------------------------------" )
		wordWrap( "Wrong! The answer was " .. answer .. ". You have " .. points .. " points. Press any key to continue.", 1, 14, 7, SCREEN_TOP )
	end
	DSLua.WaitForAnyKey()
	BGTopText:Clear()
end

wordWrap( "That is the end of this game! You got " .. points .. " points!", 0, 0, 7, SCREEN_TOP )

percentage = tonumber( points ) / tonumber( number_of_questions ) * 100
percentage_ceil = math.ceil( percentage ) - percentage
percentage_floor = percentage - math.floor( percentage )
if percentage_floor < percentage_ceil then
	rounded_percentage = math.floor( percentage )
else
	rounded_percentage = math.ceil( percentage )
end

BGTopText:PrintXY( 1, 3, rounded_percentage .. "%" )

for delay = 1, 50000 do
end

DSLua.WaitForAnyKey()