-- Functions 1.5
-- ~~~~~~~~~~~~~
--
-- Authors: Jeremysr & Daltonlaffs
-- From DSLua.com

-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- To use these functions, simply put this line at the top of your program, and you're ready to go:

--		 require( "functions.inc.lua" )

-- Put that in without the two hyphens (-- )

-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


-- If you're using SciTE, change language to "Baan" to better view the list of functions. Otherwise, if you can do this in your text editor, change the font to something like courier.

-------------------------------------------------------------------------------- 
--                    List of functions and their uses                        -- 
-------------------------------------------------------------------------------- 
-- delay(delayamount)                                                         -- 
-- ~~~~~~~~~~~~~~~~~~							      -- 
-- Counts up to delayamount before continuing. Use this to stop sprites from  -- 
-- moving too fast.         						      -- 
--									      -- 
-- waitForStylus()            						      -- 
-- ~~~~~~~~~~~~~~~							      -- 
-- Waits until the stylus touches the screen before continuing.               -- 
-- 									      -- 
-- stylusInBox(x1, y1, x2, y2)						      -- 
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~						      -- 
-- x1 and y1 are the coordinates for the top-left corner of the rectangle and -- 
-- the x2 and y2 are for the bottom-right corner. The rectangle that these    -- 
-- values show will be the rectangle that the function checks to see if the   -- 
-- stylus is touching that rectangle.					      -- 
--                                  					      --  
-- setTextColor(textcolor, screen)					      -- 
-- ~~~~~~~~~~~~~~~~~~~~~~~						      -- 
-- This function eliminates the need to memorize the 8 colors of text and     -- 
-- their number codes. Just input the text color as a string (i.e. "red") and -- 
-- it will pick the right color code and set the screen to that color. The    -- 
-- screen argument can be either 1 or 0. So you can use SCREEN_TOP and        -- 
-- SCREEN_BOTTOM, if you use those two variables like they do in the examples -- 
-- that come with DSLua. (0 is bottom screen, 1 is top screen.) The color     -- 
-- names are: black red green blue magenta cyan yellow lightgray darkgray     -- 
-- This function assumes your top screen is called BGTopText and your bottom  --
-- screen is called BGBotText.						      --
--									      -- 
-- printCenter(txt, y, screen)						      -- 
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~						      -- 
-- This will print txt to the screen, in y column, on the screen specified.   -- 
-- txt must be 32 characters or less. y must be <=24. screen can be 1 or 0,   -- 
-- as always. Make sure your screen is called either BGTopText or BGBotText.  -- 
--									      -- 
-- getLanguage()							      -- 
-- ~~~~~~~~~~~~~							      -- 
-- What this does is return the language as a string, like "ENGLISH" or       -- 
-- "JAPANESE", instead of using DSLua.Language() which returns 0, 1, 2, etc.  -- 
-- Thanks to Daltonlaffs for testing out all the languages and telling me     --
-- them! :D 								      --
--									      -- 
-- easySprite(spritenumber, screen, raw, pal, frames, dimx, dimy)	      -- 
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~			      -- 
-- spritenumber should be different each time you use this. It is the number  --
-- used used with each easysprite. screen is either 1 or 0 as always. raw is  --
-- the filename of your raw sprite file. pal is the filename of your palette  --
-- file. frames is the number of frames in your framestrip. dimx and dimy are --
-- the dimensions of your sprite. For example, if you called:		      --
-- 									      --
-- easySprite( 1, SCREEN_TOP, "mario.raw", "mario.pal", 3, 32, 32 )           --
--									      --
-- You could move the sprite where you want it like this:		      --
-- 									      --
-- EASYSPRITE[1]:MoveTo( x, y )						      --
--									      --
-- 1 is the variable spritenumber.					      --
-- 									      -- 
-- setUpTextScreens(screen)						      -- 
-- ~~~~~~~~~~~~~~~~~~~~~~~~						      -- 
-- This will easily set up the screen(s) you want to display text. screen can -- 
-- be 0, 1, or 2. 0 is bottom screen, 1 is top screen, 2 is both. Top screen  -- 
-- will be called BGTopText and bottom screen will be called BGBotText.       --
-- 									      -- 
-- delaySeconds(seconds)						      -- 
-- ~~~~~~~~~~~~~~~~~~~~~						      -- 
-- Originally, the idea was by Jeremysr. But I, daltonlaffs, have fixed the   --
-- function to his specifications (he had no way of hardware testing, so he   --
-- could not figure out how high a regular DS could count in a second.)       --
-- This function makes DSLua pause for the number of seconds you put in the   --
-- parenthesis! Hope you enjoy my work!                                       --
--									      -- 
-- Sprite.SpriteTotalFree(sprite, framestrip, palette)                        --     
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        -- 
-- This function by daltonlaffs completely frees a sprite, its                -- 
-- corresponding framestrip, and its corresponding palette.                   --
-- Hope you like it!                                                          -- 
--                                                                            -- 
-- DSLua.WaitForAnyButton()                                                   --
-- ~~~~~~~~~~~~~~~~~~~~~~~~                                                   --
-- This function, also made by daltonlaffs, is just like                      --
-- DSLua.WaitForAnyKey(), but L and R will NOT make it continue. (This was    --
-- made because if you close the DS with the DSLua.WaitForAnyKey() command    --
-- enabled and put it in your pocket, it will definately hit L or R)          --
--                                                                            --
-- FreezeCode()                                                               --
-- ~~~~~~~~~~~~                                                               --
-- Another function by daltonlaffs, it COMPLETELY freezes your program. There --
-- is no way to stop it after it starts, other than restarting.               --
-- This command is for debugging, or if the user is supposed to shut down.    --
--                                                                            --
-- NoFreeze("True"/"False")                                                   --
-- ~~~~~~~~~~~~~~~~~~~~~~~~                                                   --
-- Yet another function by daltonlaffs. If you put "True" in the box,         --
-- FreezeCode() will not do anything! If you put "False" in the box, it       --
-- will work again. Just in case you forget that you shouldn't freeze it. :P  --
-- Typing anything other than "True" or "False" will do absolutely nothing!   --
--                                                                            --
-- equal( value1, value2 )   			                              --
-- ~~~~~~~~~~~~~~~~~~~~~~~                                                    --
-- Returns true if both values are equal, otherwise false.		      --
--                                                                            --
-- getColor()								      --
-- ~~~~~~~~~~								      --
-- Returns the colour the DS is set to as a string instead of the number-code --
-- that DSLua.Color() returns. The 16 possible colours are:		      --
-- GRAY, MAROON, RED, PINK, ORANGE, YELLOW, LIME, GREEN, DARK GREEN, TEAL,   --
-- LIGHT BLUE, BLUE, DARK BLUE, DARK PURPLE, LIGHT PURPLE, DARK PINK.	      --
--									      --
-- These are case sensitive (all uppercase) and don't forget the spaces.      --
--									      --
-------------------------------------------------------------------------------- 
-- 			    Functions begin here 			      -- 
-------------------------------------------------------------------------------- 

-------------------------------------
--       JEREMYSR'S FUNCTIONS      --
-------------------------------------

function delay(delay)
	for x=1,delay do
	end
end

function waitForStylus()
	x = 0
	while x == 0 do
		if Stylus.Down() then
			x = 1
		end
	end
end

function stylusInBox(x1, y1, x2, y2)
	if Stylus.X() >= x1 and Stylus.X() <= x2 and Stylus.Y() <= y2 and Stylus.Y() >= y1 then
		return true
	else
		return false
	end
end

function setTextColor(x, screen)
	if x == "black" then
		if screen == 0 then
			BGBotText:SetColor( 0 )
		else
			BGTopText:SetColor( 0 )
		end
	end
	if x == "red" then
		if screen == 0 then
			BGBotText:SetColor( 1 )
		else
			BGTopText:SetColor( 1 )
		end
	end
	if x == "green" then
		if screen == 0 then
			BGBotText:SetColor( 2 )
		else
			BGTopText:SetColor( 2 )
		end
	end
	if x == "blue" then
		if screen == 0 then
			BGBotText:SetColor( 3 )
		else
			BGTopText:SetColor( 3 )
		end
	end
	if x == "magenta" then
		if screen == 0 then
			BGBotText:SetColor( 4 )
		else
			BGTopText:SetColor( 4 )
		end
	end
	if x == "cyan" then
		if screen == 0 then
			BGBotText:SetColor( 5 )
		else
			BGTopText:SetColor( 5 )
		end
	end
	if x == "yellow" then
		if screen == 0 then
			BGBotText:SetColor( 6 )
		else
			BGTopText:SetColor( 6 )
		end
	end
	if x == "lightgray" then
		if screen == 0 then
			BGBotText:SetColor( 7 )
		else
			BGTopText:SetColor( 7 )
		end
	end
	if x == "darkgray" then
		if screen == 0 then
			BGBotText:SetColor( 8 )
		else
			BGTopText:SetColor( 8 )
		end
	end
end

function printCenter(txt, y, screen)
	length = string.len( txt )
	x = 16 - (length / 2)
	if screen == 0 then
		BGBotText:PrintXY( x, y, txt )
	else
		BGTopText:PrintXY( x, y, txt )
	end
end

function getLanguage()
	if DSLua.Language() == "0" then
		return "JAPANESE"
	end
	if DSLua.Language() == "1" then
		return "ENGLISH"
	end
	if DSLua.Language() == "2" then
		return "FRENCH"
	end
	if DSLua.Language() == "3" then
		return "GERMAN"
	end
	if DSLua.Language() == "4" then
		return "ITALIAN"
	end
	if DSLua.Language() == "5" then
		return "SPANISH"
	end
	if tonumber( DSLua.Language() ) > 5 then
		return "CHINESE" -- iQue DS's in china have a chinese language. All other DS's don't. So couldn't test this one.
	end
end

EASYSPRITE = {}
EASYPALETTES = {}
EASYFRAMES = {}
function easySprite(spritenumber, screen, raw, pal, frames, dimx, dimy)
	EASYPALETTES[spritenumber] = spritenumber
	Sprite.LoadPalette( screen, EASYPALETTES[spritenumber], pal )
	EASYFRAMES[spritenumber] = FrameStrip.Create( screen, dimx, dimy, "256" )
	EASYFRAMES[spritenumber]:LoadBin( raw, frames )
	EASYSPRITE[spritenumber] = Sprite.Create( EASYFRAMES[spritenumber], 0, EASYPALETTES[spritenumber], 257, 193 )
end

function setUpTextScreens(screen)
	if screen == 0 then
		SCREEN_BOTTOM = 0
		BGBotText = Screen.LoadTextBG()
		Screen.Initialize( SCREEN_BOTTOM, BGBotText )
	elseif screen == 1 then
		SCREEN_TOP = 1
		BGTopText = Screen.LoadTextBG()
		Screen.Initialize( SCREEN_TOP, BGTopText )
	elseif screen == 2 then
		SCREEN_BOTTOM = 0
		BGBotText = Screen.LoadTextBG()
		Screen.Initialize( SCREEN_BOTTOM, BGBotText )
		SCREEN_TOP = 1
		BGTopText = Screen.LoadTextBG()
		Screen.Initialize( SCREEN_TOP, BGTopText )
	end
end

function getColor()
	if DSLua.Color() == 0 then
		return "GRAY"
	end
	if DSLua.Color() == 1 then
		return "MAROON"
	end
	if DSLua.Color() == 2 then
		return "RED"
	end
	if DSLua.Color() == 3 then
		return "PINK"
	end
	if DSLua.Color() == 4 then
		return "ORANGE"
	end
	if DSLua.Color() == 5 then
		return "YELLOW"
	end
	if DSLua.Color() == 6 then
		return "LIME"
	end
	if DSLua.Color() == 7 then
		return "GREEN"
	end
	if DSLua.Color() == 8 then
		return "DARK GREEN"
	end
	if DSLua.Color() == 9 then
		return "TEAL"
	end
	if DSLua.Color() == 10 then
		return "LIGHT BLUE"
	end
	if DSLua.Color() == 11 then
		return "BLUE"
	end
	if DSLua.Color() == 12 then
		return "DARK BLUE"
	end
	if DSLua.Color() == 13 then
		return "DARK PURPLE"
	end
	if DSLua.Color() == 14 then
		return "LIGHT PURPLE"
	end
	if DSLua.Color() == 15 then
		return "DARK PINK"
	end
end

function wordWrap( txt, x, y, colour, screen )
	-- This first part will seperate the text into an array, each array section will hold a word
	txt = txt .. " "
	unusedvariable, numberofspaces = string.gsub(txt, " ", " ")
	numberofwords = numberofspaces
	words = {}
	current_position = 0
	for seperateTxtIntoWords = 1, numberofwords do
		current_word = ""
		isthereaspace = false
		while isthereaspace == false do
			current_position = current_position + 1
			current_char = string.sub( txt, current_position, current_position )
			if current_char == " " then
				isthereaspace = true
			else
				current_word = current_word .. current_char
			end
		end
		words[seperateTxtIntoWords] = current_word
	end
	
	-- Now we can print it out to the screen
	if screen == 0 then
		BGBotText:SetColor( colour )
		current_x_position = x
		current_y_position = y
		for printOutWordWrapped = 1, numberofwords do
			current_word = words[printOutWordWrapped]
			current_word_length = string.len( current_word )
			end_of_screen = 32 - current_x_position + current_word_length
			if current_x_position + current_word_length <= 32 then
				BGBotText:PrintXY( current_x_position, current_y_position, words[printOutWordWrapped] .. " " )
				current_x_position = current_x_position
			else
				current_x_position = 0
				current_y_position = current_y_position + 1
				BGBotText:PrintXY( current_x_position, current_y_position, words[printOutWordWrapped] .. " " )
			end
			current_x_position = current_x_position + 1 + current_word_length
		end
	end
	if screen == 1 then
		BGTopText:SetColor( colour )
		current_x_position = x
		current_y_position = y
		for printOutWordWrapped = 1, numberofwords do
			current_word = words[printOutWordWrapped]
			current_word_length = string.len( current_word )
			end_of_screen = 32 - current_x_position + current_word_length
			if current_x_position + current_word_length <= 32 then
				BGTopText:PrintXY( current_x_position, current_y_position, words[printOutWordWrapped] .. " " )
				current_x_position = current_x_position
			else
				current_x_position = 0
				current_y_position = current_y_position + 1
				BGTopText:PrintXY( current_x_position, current_y_position, words[printOutWordWrapped] .. " " )
			end
			current_x_position = current_x_position + 1 + current_word_length
		end
	end
end

-------------------------------------
--    DALTONLAFFS'S FUNCTIONS      --
-------------------------------------

function delaySeconds(seconds)
delcountalpha = 0
delcountbeta = seconds
	while true do
		delay(1)
		delcountalpha = delcountalpha + 1
		if delcountalpha == ( ( delcountbeta * 3844 ) * 2 ) then
			break
		end
	end
end



function Sprite.SpriteTotalFree(mysprite, myframestrip, mypalette)
	mysprite:Free()
	myframestrip:FreeAll()
	mysprite = nil
	myframestrip = nil
	mypalette = nil
end

function DSLua.WaitForAnyButton()
	while true do
		if Pads.A() then
			break
		end
		if Pads.B() then
			break
		end
		if Pads.X() then
			break
		end
		if Pads.Y() then
			break
		end
		if Pads.Start() then
			break
		end
		if Pads.Select() then
			break
		end
		if Pads.Up() then
			break
		end
		if Pads.Down() then
			break
		end
		if Pads.Left() then
			break
		end
		if Pads.Right() then
			break
		end
	end
end

function FreezeCode()
	if Freezecanhappen == nil then
		Freezecanhappen = 1
	end
	if Freezecanhappen == 1 then
		while true do
			
		end
	end
end

function NoFreeze(CanInotfreeze)
	if CanInotfreeze == "True" then
		Freezecanhappen = 2
	end
	if CanInotfreeze == "False" then
		Freezecanhappen = 1
	end
end

function equal( number1, number2 )
	if number1 == number2 then
		return true
	else
		return false
	end
end