require( "functions.inc.lua" )

SCREEN_TOP = 1
SCREEN_BOTTOM = 0

-- Remove one of the dashes on the line below this one if you are using the bottom screen in your program. Otherwise this will draw the keyboard as soon as you require( "keyboard.inc.lua" )
---[[
BGBotKeyboard = Screen.LoadTileBG()
BGBotKeyboard:LoadPalette( "keyboard.pal" )
BGBotKeyboard:LoadTiles( "keyboard.raw", 256 )
BGBotKeyboard:LoadMap( "keyboard.map", (256 / 8 ), ( 192 / 8 ) )
BGBotText = Screen.LoadTextBG()
Screen.Initialize( SCREEN_BOTTOM, BGBotText, BGBotKeyboard )
--]]

function keyboard()
	-- Load the button marker
	PALETTE_MARKER = 15
	Sprite.LoadPalette( 0, PALETTE_MARKER, "selectedkey.pal" )
	SelectedKeyFrames = FrameStrip.Create( 0, 16, 16, "256" )
	SelectedKeyFrames:LoadBin( "selectedkey.raw", 1 )
	
	-- Set up some screen variales
	SCREEN_TOP = 1
	SCREEN_BOTTOM = 0
	
	-- First draw the keyboard and set up the screen to display text
	BGBotKeyboard = Screen.LoadTileBG()
	BGBotKeyboard:LoadPalette( "keyboard.pal" )
	BGBotKeyboard:LoadTiles( "keyboard.raw", 256 )
	BGBotKeyboard:LoadMap( "keyboard.map", (256 / 8 ), ( 192 / 8 ) )
	BGBotText = Screen.LoadTextBG()
	Screen.Initialize( SCREEN_BOTTOM, BGBotText, BGBotKeyboard )
	
	BGBotText:SetColor( 1 )
	
	characters = {}
	characters[0] = ""
	fullString = ""
	
	for count=1,99 do
		if characters[count] == nil then
			stringSize = count - 1
			break
		end
	end
	
	-- The keyboard doesn't seem to detect the first button pressed, but then detects the second one and all the ones afterward. This line will fix that by pretending they pressed a button.
	insertCharacter( "0", 1, 1 )
	
	-- Now keep looping until the enter key is pressed. The enter key is not rectangluar, but it can be divided into two rectangluar parts.
	enterkeypressed = false
	BGBotText:PrintXY( 2, 1, "_" )
	while enterkeypressed == false do
		-- Now for the 26letters+10digits+1space+1backspace = 38 buttons to detect...
		if Stylus.Down() then
				for count=1,99 do
					if characters[count] == nil then
						stringSize = count - 1
						break
					end
				end
				
			--------------------------------------------------------------------------------------------------------
			
			
			-- 1
			if stylusInBox( 40, 71, 54, 85 ) then
				insertCharacter( "1", 40, 71 )
			end
			
			-- 2
			if stylusInBox( 55, 71, 69, 85 ) then
				insertCharacter( "2", 55, 71 )
			end
			
			-- 3
			if stylusInBox( 70, 71, 84, 85 ) then
				insertCharacter( "3", 70, 71 )
			end
			
			-- 4
			if stylusInBox( 85, 71, 99, 85 ) then
				insertCharacter( "4", 85, 71 )
			end
			
			-- 5
			if stylusInBox( 100, 71, 114, 85 ) then
				insertCharacter( "5", 100, 71 )
			end
			
			-- 6
			if stylusInBox( 115, 71, 129, 85 ) then
				insertCharacter( "6", 115, 71 )
			end
			
			-- 7
			if stylusInBox( 130, 71, 144, 85 ) then
				insertCharacter( "7", 130, 71 )
			end
			
			-- 8
			if stylusInBox( 145, 71, 159, 85 ) then
				insertCharacter( "8", 145, 71 )
			end
			
			-- 9
			if stylusInBox( 160, 71, 174, 85 ) then
				insertCharacter( "9", 160, 71 )
			end
			
			-- 0
			if stylusInBox( 175, 71, 189, 85 ) then
				insertCharacter( "0", 175, 71 )
			end
			
			-- Backspace
			if stylusInBox( 190, 71, 205, 85 ) then
				backspace( 190, 71 )
			end
			
			-- A
			if stylusInBox( 54, 101, 68, 115 ) then
				insertCharacter( "A", 54, 101 )
			end
			
			-- B
			if stylusInBox( 121, 116, 135, 130 ) then
				insertCharacter( "B", 121, 116 )
			end
			
			-- C
			if stylusInBox( 91, 116, 105, 130 ) then
				insertCharacter( "C", 91, 116 )
			end
			
			-- D
			if stylusInBox( 84, 101, 98, 115 ) then
				insertCharacter( "D", 84, 101 )
			end
			
			-- E
			if stylusInBox( 77, 86, 91, 100 ) then
				insertCharacter( "E", 77, 86 )
			end
			
			-- F
			if stylusInBox( 99, 101, 113, 115 ) then
				insertCharacter( "F", 99, 101 )
			end
			
			-- G
			if stylusInBox( 114, 101, 128, 115 ) then
				insertCharacter( "G", 114, 101 )
			end
			
			-- H
			if stylusInBox( 129, 101, 143, 115 ) then
				insertCharacter( "H", 129, 101 )
			end
			
			-- I
			if stylusInBox( 152, 86, 166, 100 ) then
				insertCharacter( "I", 152, 86 )
			end
			
			-- J
			if stylusInBox( 144, 101, 158, 115 ) then
				insertCharacter( "J", 144, 101 )
			end
			
			-- K
			if stylusInBox( 159, 101, 173, 115 ) then
				insertCharacter( "K", 159, 101 )
			end
			
			-- L
			if stylusInBox( 174, 101, 188, 115 ) then
				insertCharacter( "L", 174, 101 )
			end
			
			-- M
			if stylusInBox( 151, 116, 165, 130 ) then
				insertCharacter( "M", 151, 116 )
			end
			
			-- N
			if stylusInBox( 136, 116, 150, 130 ) then
				insertCharacter( "N", 136, 116 )
			end
			
			-- O
			if stylusInBox( 167, 86, 181, 100 ) then
				insertCharacter( "O", 167, 86 )
			end
			
			-- P
			if stylusInBox( 182, 86, 196, 100 ) then
				insertCharacter( "P", 182, 86 )
			end
			
			-- Q
			if stylusInBox( 47, 86, 61, 100 ) then
				insertCharacter( "Q", 47, 86 )
			end
			
			-- R
			if stylusInBox( 92, 86, 106, 100 ) then
				insertCharacter( "R", 92, 86 )
			end
			
			-- S
			if stylusInBox( 69, 101, 83, 115 ) then
				insertCharacter( "S", 69, 101 )
			end
			
			-- T
			if stylusInBox( 107, 86, 121, 100 ) then
				insertCharacter( "T", 107, 86 )
			end
			
			-- U
			if stylusInBox( 137, 86, 151, 100 ) then
				insertCharacter( "U", 137, 86 )
			end
			
			-- V
			if stylusInBox( 106, 116, 120, 130 ) then
				insertCharacter( "V", 106, 116 )
			end
			
			-- W
			if stylusInBox( 62, 86, 76, 100 ) then
				insertCharacter( "W", 62, 86 )
			end
			
			-- X
			if stylusInBox( 76, 116, 90, 130 ) then
				insertCharacter( "X", 76, 116 )
			end
			
			-- Y
			if stylusInBox( 122, 86, 136, 100 ) then
				insertCharacter( "Y", 122, 86 )
			end
			
			-- Z
			if stylusInBox( 61, 116, 75, 130 ) then
				insertCharacter( "Z", 61, 116 )
			end
			
			-- Space
			if stylusInBox( 91, 131, 174, 144 ) then
				insertCharacter( " ", 140, 131 )
			end
			
			
			--------------------------------------------------------------------------------------------------------
			
			-- Enter
			if stylusInBox( 189, 101, 206, 130 ) or stylusInBox( 166, 116, 206, 130 ) then
				enterkeypressed = true
			end
			
		end
		
	end
	BGBotText:Clear()
	
	return fullString
end

function insertCharacter( char, x, y )
	for move = stringSize,1,-1 do
		characters[move] = characters[move+1]
	end
	characters[1] = char
	-- Now, we show that that button is currently being pushed by using the button marker...
	SelectedKey = Sprite.Create( SelectedKeyFrames, 0, PALETTE_MARKER, x, y )
	while Stylus.Down() do
	end
	SelectedKey:Free()
	fullString = fullString .. characters[stringSize]
	BGBotText:Clear()
	BGBotText:PrintXY( 2, 1, fullString .. "_" )
end

function backspace( x, y )
	-- Now, we show that that button is currently being pushed by using the button marker...
	SelectedKey = Sprite.Create( SelectedKeyFrames, 0, PALETTE_MARKER, x, y )
	while Stylus.Down() do
	end
	SelectedKey:Free()
	characters[stringSize-1] = nil
	fullString = string.sub( fullString, 1, string.len(fullString)-1 )
	BGBotText:Clear()
	BGBotText:PrintXY( 2, 1, fullString .. "_" )
end